<?php

declare(strict_types=1);

namespace Drupal\contact_automatic_subject\Hooks;

use Drupal\contact_automatic_subject\Entity\Message;
use Drupal\hux\Attribute\Alter;

/**
 * Contact message entity replace hook implementation.
 */
class ReplaceMessageEntity {

  #[Alter('entity_type')]
  /**
   * Replaces core contact message entity with our own.
   *
   * @param \Drupal\Core\Entity\EntityTypeInterface[] $entityTypes
   *
   * @see \hook_entity_type_alter()
   */
  public function replace(array &$entityTypes): void {

    $messageType = &$entityTypes['contact_message'];

    // Don't alter if it's been replaced by another extension.
    if ($messageType->getClass() !== $messageType->getOriginalClass()) {
      return;
    }

    $messageType->setClass(Message::class);

  }

}
